# \[v2] Get Bitcoin UTXOs (Mempool-Aware)

## GET /v2/bitcoin/address/{address}/utxo

> Mempool-aware: Retrieve UTXOs. This endpoint considers both confirmed and unconfirmed\
> &#x20;        utxos. When a confirmed UTXO is spent in the mempool, it will not be returned here as its no longer a utxo.\
> &#x20;         To query confirmed-only endpoint use \<code> /v1/bitcoin/address/:address/utxo\</code>.\
> &#x20;          \<br>\
> &#x20;         Iterate using offset if hasMore is true.\
> &#x20;          \<br>\<br>\
> &#x20;         \<b>UTXO filtering:\</b>\<br>\
> &#x20;         \<code>excludeNonVoidProtocolInscriptionUtxos\</code> - When true, excludes UTXOs that hold valuable\
> &#x20;         inscriptions, but can include void protocol inscriptions (e.g. BRC-20, TAP spent inscriptions).\<br>\
> &#x20;         \<code>excludeAllInscriptionUtxos\</code> - When true, excludes all inscription-bearing UTXOs,\
> &#x20;          including both valuable inscriptions(non-void protocol inscriptions) and void protocol inscriptions.\
> &#x20;           Implies \<code>excludeNonVoidProtocolInscriptionUtxos=true\</code>.

```json
{"openapi":"3.0.3","info":{"title":"SecretKeyLabs API","version":"1.0.0"},"tags":[{"name":"Bitcoin"}],"servers":[{"url":"https://api.secretkeylabs.io"}],"security":[{"apiKey":[]}],"components":{"securitySchemes":{"apiKey":{"type":"apiKey","name":"x-api-key","in":"header"}}},"paths":{"/v2/bitcoin/address/{address}/utxo":{"get":{"tags":["Bitcoin"],"description":"Mempool-aware: Retrieve UTXOs. This endpoint considers both confirmed and unconfirmed\n         utxos. When a confirmed UTXO is spent in the mempool, it will not be returned here as its no longer a utxo.\n          To query confirmed-only endpoint use <code> /v1/bitcoin/address/:address/utxo</code>.\n           <br>\n          Iterate using offset if hasMore is true.\n           <br><br>\n          <b>UTXO filtering:</b><br>\n          <code>excludeNonVoidProtocolInscriptionUtxos</code> - When true, excludes UTXOs that hold valuable\n          inscriptions, but can include void protocol inscriptions (e.g. BRC-20, TAP spent inscriptions).<br>\n          <code>excludeAllInscriptionUtxos</code> - When true, excludes all inscription-bearing UTXOs,\n           including both valuable inscriptions(non-void protocol inscriptions) and void protocol inscriptions.\n            Implies <code>excludeNonVoidProtocolInscriptionUtxos=true</code>.","parameters":[{"schema":{"default":0,"minimum":0,"type":"number"},"in":"query","name":"offset","required":false},{"schema":{"default":60,"minimum":25,"maximum":5000,"type":"number"},"in":"query","name":"limit","required":false},{"schema":{"default":false,"type":"boolean"},"in":"query","name":"excludeNonVoidProtocolInscriptionUtxos","required":false},{"schema":{"default":false,"type":"boolean"},"in":"query","name":"excludeAllInscriptionUtxos","required":false},{"schema":{"minLength":10,"default":"bc1q0egjvlcfq77cxd9kvpgppyuxckzvws46e3sxch","format":"BitcoinAddress","type":"string"},"in":"path","name":"address","required":true}],"responses":{"200":{"description":"Paginated Utxo list","content":{"application/json":{"schema":{"description":"Paginated Utxo list","type":"object","properties":{"hasMore":{"type":"boolean"},"items":{"type":"array","items":{"type":"object","properties":{"txid":{"type":"string"},"vout":{"type":"number"},"value":{"type":"number"},"status":{"type":"object","properties":{"confirmed":{"type":"boolean"},"blockHeight":{"type":"number"},"blockHash":{"type":"string"},"blockTime":{"type":"number"}},"required":["confirmed"]}},"required":["txid","vout","value","status"]}}},"required":["hasMore","items"]}}}},"400":{"description":"Invalid input","content":{"application/json":{"schema":{"description":"Invalid input","type":"string"}}}},"401":{"description":"Unauthorized","content":{"application/json":{"schema":{"description":"Unauthorized","type":"string"}}}},"404":{"description":"Not found","content":{"application/json":{"schema":{"description":"Not found","type":"string"}}}},"429":{"description":"Rate limit exceeded","content":{"application/json":{"schema":{"description":"Rate limit exceeded","type":"string"}}}},"500":{"description":"Internal server error","content":{"application/json":{"schema":{"description":"Internal server error","type":"string"}}}}}}}}}
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.xverse.app/api/bitcoin/address/v2-get-bitcoin-utxos-mempool-aware.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
